<?php

class formWidgetGroupfieldsItemFieldsOptions extends cmsForm {

    public function init($options=false) {
		
		$cats_list = array();
		$datasets_list = array('0'=>'');
		$fields_list = array(''=>'');
		$groups_list = array(''=>'');
		
		if (!empty($options['ctype_id'])){
			$content_model = cmsCore::getModel('content');	
			$ctype = $content_model->getContentType($options['ctype_id']);
			$cats = $content_model->getCategoriesTree($ctype['name']);

			if ($cats){ 
				foreach($cats as $cat){
				if ($cat['ns_level'] > 0){
					if ($cat['ns_level'] == 1){
						$cat['title'] = '['.mb_strtoupper($cat['title']).']';
					
					}
					$cats_list[] = $cat;

				}
				}

				}
		
			
			$datasets = $content_model->getContentDatasets($options['ctype_id']);			
			if ($datasets){ $datasets_list = array('0'=>'') + array_collection_to_list($datasets, 'id', 'title'); }
			
			$fields = $content_model->filterNotEqual('type','groupfields')->getContentFields($ctype['name']);
			if ($fields){ $fields_list = array_collection_to_list($fields, 'name', 'title'); }	
            $groups = $content_model->filterEqual('type','groupfields')->getContentFields($ctype['name']);	
			if ($groups){ $groups_list = array_collection_to_list($groups, 'name', 'title'); }	
			
			
		}
		
        return array(
			
            array(
                'type' => 'fieldset',
                'title' => LANG_OPTIONS,
                'childs' => array(
				
				
new fieldList('options:view_style', array(
                        'title' => "Выберите вариант отображения групп:",
						    'default' => 'tabs',
							'hint' => 'Вариант [Вкладки (с переходом в аккордеон)] при маленьких разрешениях может переходить в режим аккордеон)',							
                        'items' => array(
						'def' => "Список",
						'cols' => "Колонки",
                            'tabs' => "Вкладки(с переходом в аккордеон)",
							  'tabs_static' => "Вкладки(всегда)",
							 'acc' => "Аккордеон",
                        )
						
                    )),	
							
		new fieldNumber('options:cols_num', array(
                        'title' => 'Кол-во колонок',
                    )),		

	new fieldString('options:tabs_breakpoint', array(
                        'title' => "Точка перехода вкладок в аккордеон",
						 'hint' => "По умолчанию(px): 768",
                    )),	
		new fieldList('options:tabs_contentHeight', array(
                        'title' => "Определение высаты контейнера для вкладок",
						'items' => array(
						'auto' => "auto",
							'fixed' => "fixed",
						)
                    )),							

					
					
					
                   // new fieldList('options:ctype_id', array(
                       // 'title' => LANG_CONTENT_TYPE,
                      //  'generator' => function($item) {

                      //      $model = cmsCore::getModel('content');
                        //    $tree = $model->getContentTypes();

                        //    $items = array();

                       //     if ($tree) {
                         //       foreach ($tree as $item) {
                           //         $items[$item['id']] = $item['title'];
                           //     }
                         //   }

                        //    return $items;

                      //  },
                   // )),
							
		
                 //   new fieldList('options:dataset', array(
                     //   'title' => 'Фильтр по набору',
					//	'parent' => array(
					//		'list' => 'options:ctype_id',
					//		'url' => href_to('content', 'widget_datasets_ajax')
					//	),
					//	'items' => $datasets_list
                   // )),

 

//new fieldListmultiple('options:cats', array(
						// 'title' => "Отображать только в отмеченных рубриках:",
						// 'hint' => '[РУБРИКА] - корневая рубрика', 					
						// 'items' => array_collection_to_list($cats_list, 'slug', 'title')
							   
                  //  )),			

					
//new fieldListmultiple('options:fields', array(
//'title' => 'Выберите поля для отображения:</h4>',    										
//'items' => $fields_list                         
//)),
//new fieldListmultiple('options:groups', array(
//'title' => 'Выберите группы полей для отображения:',    										
//'items' => $groups_list                         
//)),
        
						
					
				

                )
            ),

        );

    }

}
