<?php
class widgetGroupfieldsItemFields extends cmsWidget {

    public $is_cacheable = false;

    public function run(){

        $widget_ctype_name = $this->getOption('ctype_name');
		$widget_fields = $this->getOption('fields');
		$widget_groups = $this->getOption('groups');
		$widget_cats = $this->getOption('cats');

        $slug = null;

/////////////////////////////////////
$base = cmsDataBase::getInstance();
		$core = cmsCore::getInstance();
		$config = cmsConfig::getInstance();
		  $user = cmsUser::getInstance();
		$content_model = cmsCore::getModel('content');
		$content_controller = cmsCore::getController('content');
		        // Получаем название типа контента и сам тип
        $ctype_name = $core->request->get('ctype_name');
        $ctype = $content_model->getContentTypeByName($ctype_name);   
   	

		// Получаем SLUG записи
        $slug = $core->request->get('slug');
		
		if (!$ctype) {
			if ($config->ctype_default){
				$ctype = $content_model->getContentTypeByName($config->ctype_default);			
				if (!$ctype) { return false; }				
				$slug = $ctype_name . '/' . $slug;
				$ctype_name = $config->ctype_default;
			} else {
			return false;				
			}
		} else {
			$core = cmsCore::getInstance();
			if ($config->ctype_default && $config->ctype_default == $core->uri_controller){
				$content_model->redirect(href_to($slug . '.html'), 301);
			}
		}
		    // Получаем запись
        $item = $content_model->getContentItemBySLUG($ctype_name, $slug);   	
		 if (!isset($item['id'])) { return false; }


        $fields = $content_model->getContentFields($ctype_name);
		
		
		
	
	
	
		
//////////////////////////////////////////////////////////////////////
///////////////////// Сквозной вывод посредством поля
//////////////////////////////////////////////////////////////////////

///Настройки отображения

$view_style = $this->getOption('view_style');	

$is_def = ($view_style=="def") ? true : false;
$is_tabs = ($view_style=="tabs") ? true : false;
$is_tabs_static = ($view_style=="tabs_static") ? true : false;
$is_cols = ($view_style=="cols") ? true : false;
$cols_num = ($this->getOption('cols_num')) ? $this->getOption('cols_num') : false;
$is_acc = ($view_style=="acc") ? true : false;

		
		
		

		
		foreach($fields as $name=>$field){
   $fields[ $name ]['html'] = $field['handler']->parse( $item[$name] );
		//if ($field['is_in_filter']) { $fields_count++; break; }


if($field['type']=='groupfields'){



////////////////////Проверяем, входит ли запись в отмечанные категории
$item_cats = $this->getItemCats($ctype['name'], $item['id']);
foreach($item_cats as $item_cat){
	$item_cats_slugs[] = $item_cat['slug'];
}
$in_cats = $field['options']['cats'];

$cat_count = 0;
foreach($in_cats as $in_cat){
$check_cat = (is_array($item_cats_slugs) && in_array($in_cat, $item_cats_slugs));
if($check_cat){
$cat_count++;
}
}
$item_in_cat_true = $cat_count ? 1 : 0;
if(!$item_in_cat_true) { return false; }
////////////////////////////////////////////////////////////////////




///Собираем группы	
$groups[] = $fields[$name];


}			
			
			
			
		}
		
		
		
   


$count = 1;
	 foreach($groups as $group){	

if($is_tabs || $is_acc || $is_tabs_static){
    $fields_html.='<dt><a href="#">'.$group['title'].'</a></dt>';	 
	$fields_html.='<dd><div class="content_item '.$ctype['name'].'_item">';
}else if($is_cols){	 
	$fields_html.='<li class="cols_num_'.$cols_num.'"><div class="content_item '.$ctype['name'].'_item"><h3 class="group_title">'.$group['title'].'</h3>';
}else if($is_def){
    $fields_html.='<li><div class="content_item '.$ctype['name'].'_item"><h3 class="group_title">'.$group['title'].'</h3>';
}

	
    if($group['options']['fields']){ 
     foreach($group['options']['fields'] as $group_field){ 
	     $field = $fields[$group_field];  
		 


         if ($field['is_system']) { continue; } 
         if (empty($item[$field['name']])) { continue; } 
         if ($field['groups_read'] && !$user->isInGroups($field['groups_read'])) { continue; } 

        
            if (!isset($field['options']['label_in_item'])) {
                $label_pos = 'none';
            } else {
                $label_pos = $field['options']['label_in_item'];
            }
        

        $fields_html.='<div class="field ft_'.$field['type'].' f_'.$field['name'].'">';

             if ($label_pos != 'none'){ 
                $fields_html.='<div class="title_'.$label_pos.'">'.$field['title'].': </div>';
             } 

            $fields_html.='<div class="value">';                
            $fields_html.=$field['html'];             
            $fields_html.='</div>';

        $fields_html.='</div>'; 

		
    } //end foreach group_field
	}
	
	
		// Получаем поля-свойства
        if ($group['options']['and_props'] && $ctype['is_cats'] && $item['category_id'] > 1){
	
            $props = $content_model->getContentProps($ctype['name'], $item['category_id']);
            $props_values = $content_model->getPropsValues($ctype['name'], $item['id']);
			if ($props && $props_values) { 
        
            $props_fields = $content_controller->getPropsFields($props);
            $props_fieldsets = cmsForm::mapFieldsToFieldsets($props);
        
        $props_html.='<div class="content_item_props '.$ctype['name'].'_item_props">';
        $props_html.='<table>';
                $props_html.='<tbody>';
                     foreach($props_fieldsets as $fieldset){ 
                         if ($fieldset['title']){ 
                            $props_html.='<tr>';
                                $props_html.='<td class="heading" colspan="2">'.$fieldset['title'].'</td>';
                            $props_html.='</tr>';
                         } 
                         if ($fieldset['fields']){ 
                             foreach($fieldset['fields'] as $prop){ 
                                 if (isset($props_values[$prop['id']])) { 
                                 $prop_field = $props_fields[$prop['id']]; 
                                    $props_html.='<tr>';
                                        $props_html.='<td class="title">'.$prop['title'].'</td>';
                                        $props_html.='<td class="value">';
                                        $props_html.= $prop_field->parse($props_values[$prop['id']]);
                                        $props_html.='</td>';
                                    $props_html.='</tr>';
                                 } 
                             } 
                         } 
                     } 
                $props_html.='</tbody>';
            $props_html.='</table>';
        $props_html.='</div>';
     } 
		
			
        }	
	 //////////
	 
	 
	 	///////////////////////// Обработка содержания
if($group['options']['group_content']){
    $pattern[]  = "/\{(user=)\s*(.*?)\}/is";
    $replace = function($match){ 
	$user = cmsUser::getInstance();
    $profile = cmsCore::getModel('users')->getUser($item['user_id']);
	$field_name = $profile[$match[2]] ? $match[2] : false;
	$field_val = $profile[$match[2]] ? $profile[$match[2]] : false;
	
    // Получаем nickname
	if($field_name=="nickname"){
	$item = $profile['nickname'];
	}
	// Получаем аватар
	else if($match[2]=="avatar" || $match[2]=="avatar_normal" || $match[2]=="avatar_small"){
	$ava_size = ($match[2]=="avatar" || $match[2]=="avatar_small") ? 'small' : 'normal'; 	
	$item = html_avatar_image($profile['avatar'], $ava_size);
	}
	// Получаем ссылку на профиль
	else if($match[2]=="pfl" || $match[2]=="profile"){
	$item = href_to('users', $profile['id']);
	}
	//////////////////////////////////////////////////// Получаем поля
	else{
		
        $content_model = cmsCore::getModel('content');
        $content_model->setTablePrefix('');
        $content_model->orderBy('ordering');
        $fields = $content_model->getContentFields('users');		
	    $fieldsets = cmsForm::mapFieldsToFieldsets($fields, function($field, $user){
                        if (in_array($field['name'], array('nickname', 'avatar'))){ return false; }
                        return true;
                    }, $profile);
	    foreach($fieldsets as $fieldset){ 
        if (!$fieldset['fields']) { continue; }
		foreach($fieldset['fields'] as $field){
		if ($field['name'] == !$field_name) { continue; }	
		$field_html[$field['name']] = $field['handler']->parse( $profile[$field['name']] );
		$item = $field_html[$field_name];
		}
		}						
	
	} 
	////////////////////////////////////////////////// Получаем поля

	
	
	return $item;
    };
}
	$group_content = $group['options']['group_content'] ? '<div class="groupfields_content">'.preg_replace_callback($pattern, $replace, $group['options']['group_content']).'</div>' : '';
	
	////////////////////////
	 
	 
	 
	
	$fields_html.='</div>'.$props_html.$group_content;
	
	if($is_tabs || $is_acc || $is_tabs_static){
    $fields_html.='</dd>';	 
}else if($is_cols){	 
	$fields_html.='</li>';
}else if($is_def){
    $fields_html.='</li>';
}
$count++;
	 }		
		
		
	
if($is_tabs || $is_acc || $is_tabs_static){
$html='<dl id="ItemFieldsTabs" class="smart-tabs">'.$fields_html.'</dl>';
}else if($is_cols){
$html='<ul class="groupfields_cols">'.$fields_html.'</ul>';	
}else if($is_def){
$html='<ul class="groupfields_def">'.$fields_html.'</ul>';	
}	
		
		
if($is_tabs || $is_acc || $is_tabs_static){
$breakpoint = $this->getOption('tabs_breakpoint') ? $this->getOption('tabs_breakpoint') : '768';
$contentHeight = $this->getOption('tabs_contentHeight') ? $this->getOption('tabs_contentHeight') : 'auto';

	
if($is_tabs_static) $layout = 'tabs'; 
else if($is_tabs) $layout = 'auto';
else if($is_acc) $layout = 'accordion';

}
		
		
		
		
		
		
		
		
		






		
		
        return array(
			'ctype_name' => $ctype_name,
			'page_url' => $core->uri_absolute,
			'fields' => $fields,
			'props_fields' => $props_fields,
			'props' => $props,
			
				'html' => $html,
				'breakpoint' => $breakpoint,
					'contentHeight' => $contentHeight,
						'layout' => $layout,
        );

    }
	
	


public function getItemCats($ctype_name, $item_id){
		$model = cmsCore::getModel('content');
		$bind_cats = $model->getContentItemCategories($ctype_name,$item_id);
		foreach ($bind_cats as $cat_id){
			$cat = $model->getCategory($ctype_name, $cat_id);
			$cats[] = $cat;
		}
        return $cats;
		}

}
