<?php

class fieldGroupfields extends cmsFormField {

    public $title = 'Группа полей [GoodMade]';
    public $sql   = 'text';
    public $filter_type = 'str';
	public $allow_index = false;

    public function getOptions(){


	$core = cmsCore::getInstance();
	$ctype_name = $core->request->get('ctype_name');
	if(!$ctype_name){
    $ctype_name = $core->request->get('ctype');
	}
	$content_model = cmsCore::getModel('content');	
    $base = cmsDataBase::getInstance();
	
	if(!$ctype_name){
	$uri = parse_url(urldecode($_SERVER['HTTP_REFERER']), PHP_URL_QUERY-1);
	$slug = str_replace("/admin/ctypes/", "", $uri); 
	
   if(preg_match('@([a-z0-9]+)/([0-9]+)@', $slug, $matches)){
                $action = $matches[1];
				$ctype_id = $matches[2];
            } 

			$ctype = $content_model->getContentType($ctype_id);
			$ctype_name = $ctype['name'];
	}


	$datasets_list = array('0'=>'');
	$datasets = $content_model->getContentDatasets($ctype_id);			
	if ($datasets){ $datasets_list = array('0'=>'') + array_collection_to_list($datasets, 'id', 'title'); }
	
	
	     // Получаем поля для данного типа контента
        $fields_list = $content_model->filterNotEqual('type','groupfields')->getContentFields($ctype_name);	


		$cats = $content_model->getCategoriesTree($ctype_name);
		$cats_list = array();

			if ($cats){ 
				foreach($cats as $cat){
				if ($cat['ns_level'] > 0){
					if ($cat['ns_level'] == 1){
						$cat['title'] = '['.mb_strtoupper($cat['title']).']';
					
					}
					$cats_list[] = $cat;

				}
				}
			}	
			
        return array(
 
	



		
			
    new fieldList('dataset', array(
                        'title' => "<h4 style='color:#000;margin-bottom:0;'>Фильтр по набору:</h4>",
						'items' => $datasets_list
                    )),
					
				new fieldListmultiple('cats', array(
						 'title' => "<h4 style='color:#000;margin-bottom:0;'>Отображать только в отмеченных рубриках:</h4>",
						 'hint' => '[РУБРИКА] - корневая рубрика', 		
			
						 'items' => array_collection_to_list($cats_list, 'slug', 'title')
							   
                    )),			

					
new fieldListmultiple('fields', array(
'title' => '<h4 style="margin-top:20px;margin-bottom:0;color:#000">Отметьте галочкой <b>поля</b> которые будут входить в эту группу:</h4>',    										
'items' => array_collection_to_list($fields_list, 'name', 'title')                           
)),


new fieldCheckbox('and_props', array(
'title' => '<span style="margin-top:20px;margin-bottom:0;color:#000;font-size:14px">Отображать <b>свойства</b> для этого типа контента в этой группе</span>',
)),	


	
			//HTML
					new fieldHtml('group_content', array(
                        'title' => '<h4 style="margin-top:20px;margin-bottom:0;color:#000">Отображать этот HTML:</h4>',
						 'hint' => "Поддерживаются маски для вызова данных из полей профиля пользователя. Используйте [системное имя] указанное на <a href='/admin/controllers/edit/users/fields'><b>этой странице</b></a>.
						 <br/>Например: {user=nickname} сейчас проживает в {user=city}, ему {user=birth_date}.",
                    )),
				

		
					
        );
    }



}
